<template>
  <div>
    <div class="fr-p-8w">
      <div
        class="fr-grid-row"
        :class="{ 'anct-flex-column-reverse': isMobile }"
      >
        <div class="fr-tabs fr-col-lg-8 fr-col">
          <ul
            class="fr-tabs__list"
            role="tablist"
            aria-label="types de service"
          >
            <li
              v-for="(tab, index) in tabs"
              :key="`tab--${index}`"
              role="presentation"
            >
              <button
                :id="`tabpanel-${{ index }}`"
                class="fr-tabs__tab"
                :tabindex="activeTabIndex === index ? '0' : '-1'"
                role="tab"
                :aria-selected="activeTabIndex === index"
                :aria-controls="`tabpanel-${{ index }}-panel`"
                @click="updatePanel(index, tab.toggle)"
              >
                {{ tab.name }}
              </button>
            </li>
          </ul>

          <div
            v-for="(tab, index) in tabs"
            :id="`tabpanel-${{ index }}-panel`"
            :key="`tab-panel--${index}`"
            class="fr-tabs__panel"
            :class="{ 'fr-tabs__panel--selected': activeTabIndex === index }"
            role="tabpanel"
            :aria-labelledby="`tabpanel-${{ index }}`"
            :tabindex="activeTabIndex === index ? '0' : '-1'"
          >
            <p class="fr-h3">
              <strong>{{ servicesNumberString }}</strong>
            </p>

            <div class="fr-container fr-container--fluid fr-px-0">
              <FrCardsContainer class="fr-mr-2w">
                <FrCard
                  v-for="(service, serviceIndex) in services"
                  :key="`service-card--${serviceIndex}`"
                  :title="truncateString(service.value || '', 120)"
                  :to="{
                    name: 'services-slug',
                    params: { slug: service.slug },
                    query: $route.query,
                  }"
                  enlarge-link
                  class="fr-col-lg-4"
                >
                  <template #startDetail
                    ><p class="fr-card__detail">
                      {{ service.competence }}
                    </p></template
                  >

                  <template #description>
                    <p class="fr-mb-1w fr-text--sm">
                      <strong>{{ service.name }}</strong>
                    </p>

                    <p
                      v-if="service.description"
                      class="fr-text--sm"
                      v-html="truncateString(service.description)"
                    ></p>
                  </template>

                  <template #endDetail>
                    <FrTag
                      class="fr-text--xs fr-tag--icon-left"
                      :class="getTagCSSClasses(service.stage)"
                      :label="service.stage"
                    />
                  </template>
                </FrCard>
              </FrCardsContainer>
            </div>

            <FrPagination
              v-if="pagination.total > pagination.limit"
              v-model="pagination.current"
              :total="Math.ceil(pagination.total / pagination.limit)"
              class="fr-mt-4w anct-flex-center"
              @input="updatePage"
            />
          </div>
        </div>

        <div class="fr-col-lg-4">
          <FrSearch
            id="search-service"
            v-model="form.searchString"
            @input:blur="trackSearch"
            @button:click="trackSearchClick"
          />

          <div
            class="fr-mt-4w"
            :class="{
              'fr-mb-4w': isMobile,
            }"
          >
            <p v-if="!isMobile" class="fr-mb-1w fr-text--lg">
              <strong>Vous êtes</strong>
            </p>
            <button
              v-for="(value, index) in SCALE_FILTER"
              :key="`type-filter--${index}`"
              class="fr-btn fr-mr-2w fr-mb-2w fr-text--sm"
              :class="{
                'fr-btn--primary': form.scales.includes(value),
                'fr-btn--secondary': !form.scales.includes(value),
              }"
              :aria-pressed="form.scales.includes(value)"
              @click="toggleScale(value)"
            >
              {{ value }}
            </button>
          </div>

          <div v-if="!isMobile">
            <div class="fr-mt-4w">
              <p class="fr-pb-1w fr-text--lg border-bottom-primary">
                <strong>À quel sujet</strong>
              </p>
              <button
                v-for="(value, index) in THEME_FILTER"
                :key="`theme-filter--${index}`"
                class="fr-btn fr-mr-2w fr-mb-2w fr-text--sm"
                :class="{
                  'fr-btn--primary': form.themes.includes(value),
                  'fr-btn--secondary': !form.themes.includes(value),
                }"
                :aria-pressed="form.themes.includes(value)"
                @click="toggleTheme(value)"
              >
                {{ value }}
              </button>
            </div>

            <div class="fr-mt-4w">
              <div class="fr-select-group">
                <label class="fr-label fr-text--lg fr-mb-1w" for="select">
                  <strong>Programme de l'Incubateur</strong>
                </label>
                <select
                  id="select"
                  v-model="form.program"
                  class="fr-select"
                  name="select"
                >
                  <option value="" selected disabled hidden>
                    Selectionnez une option
                  </option>
                  <option
                    v-for="(option, index) in PROGRAM_OPTIONS"
                    :key="`select-option--${index}`"
                    :value="option"
                  >
                    {{ option }}
                  </option>
                </select>
              </div>
            </div>

            <div class="fr-mt-4w">
              <div class="fr-grid-row"></div>
              <p class="fr-col fr-pb-1w fr-text--lg border-bottom-primary">
                <strong>Quels types de ressources ?</strong>
              </p>
              <FrSwitch
                v-model="form.isAvailable"
                switch-id="switch-dispo"
                label="Disponibles immédiatement"
                label-left
                class="border-bottom-primary"
              />
            </div>
          </div>
        </div>

        <button
          v-if="isMobile"
          class="fr-mb-6w fr-mt-5w anct-text-blue anct-cursor-pointer anct-button-text"
          :data-fr-opened="isFilterModalOpened"
          aria-controls="fr-modal-search-filters"
          @click="openFilterModal"
        >
          Plus de filtres
          <span
            class="fr-ml-1w fr-icon-equalizer-fill"
            aria-hidden="true"
          ></span>
        </button>
      </div>
    </div>

    <FrModal
      id="service-filters-modal"
      :opened="isFilterModalOpened"
      @close="closeFilterModal"
    >
      <div>
        <p class="fr-pb-1w fr-text--lg border-bottom-primary">
          <strong>À quel sujet</strong>
        </p>
        <button
          v-for="(value, index) in THEME_FILTER"
          :key="`theme-filter--${index}`"
          class="fr-btn fr-mr-2w fr-mb-2w fr-text--sm"
          :class="{
            'fr-btn--primary': form.themes.includes(value),
            'fr-btn--secondary': !form.themes.includes(value),
          }"
          @click="toggleTheme(value)"
        >
          {{ value }}
        </button>
      </div>

      <div class="fr-mt-4w">
        <div class="fr-select-group">
          <label class="fr-label fr-text--lg fr-mb-1w" for="modal--select">
            <strong>Programme de l'Incubateur</strong>
          </label>
          <select
            id="modal--select"
            v-model="form.program"
            class="fr-select"
            name="select"
          >
            <option value="" selected disabled hidden>
              Selectionnez une option
            </option>
            <option
              v-for="(option, index) in PROGRAM_OPTIONS"
              :key="`select-option--${index}`"
              :value="option"
            >
              {{ option }}
            </option>
          </select>
        </div>
      </div>

      <div class="fr-mt-4w">
        <div class="fr-grid-row"></div>
        <p class="fr-col fr-pb-1w fr-text--lg border-bottom-primary">
          <strong>Quels types de ressources ?</strong>
        </p>

        <div class="fr-col-8">
          <FrSwitch
            v-model="form.isService"
            switch-id="switch-service-numeriques"
            class="border-bottom-primary"
            label="Services numériques"
            label-left
          />

          <FrSwitch
            v-model="form.isGuide"
            switch-id="switch-kit"
            label="Kit et Guide"
            label-left
            class="border-bottom-primary"
          />

          <FrSwitch
            v-model="form.isAvailable"
            switch-id="modal--switch-dispo"
            label="Disponibles immédiatement"
            label-left
            class="border-bottom-primary"
          />
        </div>
      </div>

      <template #footer>
        <li class="fr-mb-12w fr-mt-2w anct-flex-end">
          <button
            class="fr-btn fr-text--md fr-grid-row fr-grid-row--middle"
            @click="closeFilterModal"
          >
            Appliquer
          </button>
        </li>
      </template>
    </FrModal>
  </div>
</template>

<script>
import cloneDeep from 'lodash.clonedeep';
import qs from 'qs';

import { INDEX } from '~/plugins/meilisearch';
import {
  SCALE_FILTER,
  THEME_FILTER,
  PROGRAM_OPTIONS,
} from '~/pages/services/data';
import { trackGoal, trackSearch, trackEvent } from '~/tools/matomo';
import FrSwitch from '~/components/form/Switch';
import FrSearch from '~/components/form/Search';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';
import FrPagination from '~/components/elements/Pagination';
import FrTag from '~/components/ui/tags/Basic';
import FrModal from '~/components/elements/Modal';

import paginationMixin, {
  getInitialPagination,
} from '~/pages/services/paginationMixin';

const initialForm = {
  searchString: '',
  scales: [],
  themes: [],
  program: '',
  isService: true,
  isGuide: false,
  isAvailable: false,
};

const initialPagination = getInitialPagination();

const tabs = [
  { toggle: 'isService', name: 'Logiciels' },
  { toggle: 'isGuide', name: 'Documentation' },
];

const initialActivePanelIndex = tabs.findIndex(
  (tab) => tab.name === 'Logiciels',
);

export const searchService = async (
  search,
  { index, pagination, filter, searchString },
) => {
  const { hits, nbHits } = await search.index(index).search(searchString, {
    filter,
    limit: pagination.limit,
    offset: (pagination.current - 1) * pagination.limit,
  });

  return {
    services: hits.map(cleanServiceFormatForCard),
    total: nbHits,
  };
};

const cleanServiceFormatForCard = (service) => ({
  ...service,
  description: service.description?.replace('\\', '') || null,
});

const getCompatibleFormFromQueryFilter = (queryFilter) =>
  queryFilter.reduce((acc, value) => {
    let key;
    let cleanedValue;

    if (typeof value === 'string') {
      [key] = value.split(' = ');
      [, cleanedValue] = value.split(' = ')[1].split('"');
    } else {
      key = value[0].split(' = ')[0].trim();
      cleanedValue = value.map((v) => v.split(' = ')[1].split('"')[1]);
    }

    switch (key) {
      case 'target':
        return { ...acc, scales: cleanedValue };
      case 'themes':
      case 'competence':
        return { ...acc, themes: cleanedValue };
      case 'program':
        return { ...acc, program: cleanedValue };
      case 'stage':
        return {
          ...acc,
          isAvailable: cleanedValue === 'Disponible',
        };
      default:
        return acc;
    }
  }, {});

export default {
  name: 'ServicesPage',

  components: {
    FrSwitch,
    FrSearch,
    FrCard,
    FrCardsContainer,
    FrPagination,
    FrTag,
    FrModal,
  },

  mixins: [paginationMixin(initialPagination)],

  layout: 'raw',

  async asyncData({ $search, query, $config }) {
    const parsedFilterQuery = qs.parse(query.filter);
    const filter = Object.values(parsedFilterQuery);
    const searchString = query.search || '';

    const { services, total } = await searchService($search, {
      index: INDEX,
      pagination: initialPagination,
      filter,
      searchString,
    });

    const formElements = {
      ...getCompatibleFormFromQueryFilter(filter),
      searchString,
    };

    const form = {
      ...cloneDeep(initialForm),
      ...formElements,
    };

    return {
      form,
      services: services.map((service) => {
        let image = null;

        if (service.images.length) {
          const [data] = service.images;
          image = `${$config.apiURL}/assets/${data.directus_files_id}`;
        }

        return {
          ...service,
          image,
        };
      }),
      pagination: {
        ...initialPagination,
        total,
      },
      isFilterModalOpened: false,
      SCALE_FILTER,
      THEME_FILTER,
      PROGRAM_OPTIONS,
      isMobile: false,
      tabs,
      activeTabIndex: initialActivePanelIndex,
    };
  },

  computed: {
    servicesNumberString() {
      const { total } = this.pagination;
      const isPlural = total > 1;

      return `${total} ressource${isPlural ? 's' : ''} disponible${
        isPlural ? 's' : ''
      } pour vous`;
    },
  },

  watch: {
    form: {
      handler() {
        this.filterServices();
      },
      deep: true,
    },
  },

  mounted() {
    this.updateResponsiveState();
    window.addEventListener('resize', this.updateResponsiveState);
  },

  destroyed() {
    window.removeEventListener('resize', this.updateResponsiveState);
  },

  methods: {
    async updatePage() {
      const filter = this.generateFilter();

      const { services, total } = await searchService(this.$search, {
        index: INDEX,
        pagination: this.pagination,
        filter,
        searchString: this.form.searchString,
      });

      this.services = services;
      this.setPagination({ total });
    },
    async filterServices() {
      const filter = this.generateFilter();
      const queryFilter = qs.stringify(filter);

      await this.$router.replace({
        path: this.$route.path,
        query: {
          ...this.$route.query,
          filter: queryFilter,
          search: this.form.searchString,
        },
      });

      const { services, total } = await searchService(this.$search, {
        index: INDEX,
        pagination: this.pagination,
        filter,
        searchString: this.form.searchString,
      });

      this.services = services;
      this.setPagination({ total, current: 1 });
    },
    generateFilter() {
      return [
        this.generateScalesFilter(),
        this.generateThemesFilter(),
        this.generateProgramFilter(),
        this.generateTypesFilter(),
        this.generateStatusFilter(),
      ].filter(({ length }) => length > 0);
    },
    generateScalesFilter() {
      const filter = this.form.scales.map((scale) => `target = "${scale}"`);

      return filter.length ? filter : '';
    },
    generateThemesFilter() {
      return this.form.themes.map(
        (theme) => `themes = "${theme}" OR competence = "${theme}"`,
      );
    },
    generateProgramFilter() {
      return this.form.program && this.form.program !== 'Tous les programmes'
        ? `program = "${this.form.program}"`
        : '';
    },
    generateStatusFilter() {
      return this.form.isAvailable ? `stage = "Disponible"` : '';
    },
    generateTypesFilter() {
      const filter = [];

      if (this.form.isService) {
        filter.push('type = "Service numérique"');
      }

      if (this.form.isGuide) {
        filter.push('type = "Kit et Guide"');
      }

      return filter.length ? filter : '';
    },

    toggleScale(value) {
      trackGoal('echelon', 1);
      if (this.form.scales.includes(value)) {
        this.form.scales = this.form.scales.filter((scale) => scale !== value);
      } else {
        this.form.scales.push(value);
      }
    },
    toggleTheme(value) {
      trackGoal('theme', 1);
      if (this.form.themes.includes(value)) {
        this.form.themes = this.form.themes.filter((theme) => theme !== value);
      } else {
        this.form.themes.push(value);
      }
    },

    truncateString(str, charNumber = 100) {
      if (str.length > charNumber) {
        return `${str.substring(0, charNumber)}...`.replace(/<[^>]+>/gi, '');
      }
      return str;
    },

    getTagCSSClasses(stage) {
      switch (stage) {
        case 'Disponible':
          return 'fr-icon-check-line anct-bg-green anct-text-green';
        case 'En test':
          return 'fr-icon-seedling-fill anct-bg-low-blue anct-text-main';
        default:
          return null;
      }
    },

    openFilterModal() {
      this.isFilterModalOpened = true;
    },
    closeFilterModal() {
      this.isFilterModalOpened = false;
    },
    trackSearch() {
      trackGoal('search', 1);
      trackSearch(this.form.searchString);
    },
    trackSearchClick() {
      trackEvent('Search', 'Click', 'Click on search buttons');
    },
    updateResponsiveState() {
      this.isMobile = window.innerWidth < this.$config.mobileBreakpoint;
    },
    updatePanel(index, filter) {
      this.activeTabIndex = index;
      this.tabs.map(({ toggle }) => (this.form[toggle] = toggle === filter));
    },
  },
};
</script>

<style scoped>
.border-bottom-primary {
  border-bottom: 1px solid var(--border-default-grey);
}

.tag-color-primary {
  color: var(--blue-france-sun-113-625);
}

.tag-color-secondary {
  color: var(--grey-50-1000);
}

.text-success-color {
  color: var(--success-425-625);
}

.fr-tabs::before {
  box-shadow: none;
}
</style>
